package com.company.master.app;

import com.company.master.view.user.UserListView;
import io.jmix.flowui.ViewNavigators;
import io.jmix.flowui.component.UiComponentUtils;
import io.jmix.flowui.view.ViewControllerUtils;
import io.jmix.flowui.view.navigation.SupportsAfterViewNavigationHandler.AfterViewNavigationEvent;
import io.jmix.flowui.view.navigation.ViewNavigationSupport;
import org.springframework.stereotype.Component;

import java.util.Map;
import java.util.function.Consumer;

@Component("MenuBean")
public class MenuBean {

    private final ViewNavigators viewNavigators;
    private final ViewNavigationSupport navigationSupport;

    public MenuBean(ViewNavigators viewNavigators, ViewNavigationSupport navigationSupport) {
        this.viewNavigators = viewNavigators;
        this.navigationSupport = navigationSupport;
    }

    public void handleMenuItem(Map<String, Object> parameters) {
        viewNavigators.view(UiComponentUtils.getCurrentView(), UserListView.class)
                .navigate();

        Consumer<AfterViewNavigationEvent<UserListView>> handler = event -> {
            UserListView view = event.getView();
            view.setMessage((String) parameters.get("message"));
        };

        navigationSupport.findCurrentNavigationTarget(UserListView.class)
                .ifPresent(view ->
                        ViewControllerUtils.setAfterNavigationHandler(
                                view,
                                () -> handler.accept(new AfterViewNavigationEvent<>(this, view))
                        )
                );
    }
}
